#include "setcolor.h"

#include <qstring.h>
#include <qlabel.h>

#include <stdio.h>

SetColorDialog::SetColorDialog(BR_Option option, QWidget *parent)
  :QDialog (parent, "Color", true )
{
  setCaption("Color Setting");
  org_bgcolor = option.bgcolor;
  org_contrast = option.contrast;
  org_level = option.contrast_level;

  setMinimumSize( 250, 250 );

  rBox = new QSpinBox( 0, 255, 1, this);
  gBox = new QSpinBox( 0, 255, 1, this);
  bBox = new QSpinBox( 0, 255, 1, this);
  
  rBox->setValue( (org_bgcolor >>16) & 0xff );
  gBox->setValue( (org_bgcolor >>8 ) & 0xff );
  bBox->setValue( (org_bgcolor     ) & 0xff );

  rBox->setGeometry( QRect(10, 60, 70, 30) );
  gBox->setGeometry( QRect(80, 60, 70, 30) );
  bBox->setGeometry( QRect(150, 60, 70, 30) );

  rBox->show();
  gBox->show();
  bBox->show();

  QLabel * title = new QLabel( "Background Color", this);
  QLabel * rLabel = new QLabel( "R", this);
  QLabel * gLabel = new QLabel( "G", this);
  QLabel * bLabel = new QLabel( "B", this);

  title->setGeometry( QRect(10, 0, 200, 30) );
  rLabel->setGeometry( QRect(30, 30, 10, 30));
  gLabel->setGeometry( QRect(100, 30, 10, 30));
  bLabel->setGeometry( QRect(170, 30, 10, 30));
 
  rLabel->show();
  gLabel->show();
  bLabel->show();


  setGray = new QRadioButton("", this);
  setGray->setGeometry( QRect(20, 120, 30, 30) );
  setGray->show();
  setGray->setChecked(option.grayscale);

  QLabel * setGrayLabel = new QLabel( "Grayscale", this);
  setGrayLabel->setGeometry( QRect(10, 90, 100, 30));
  setGrayLabel->show();



  setContrast = new QSpinBox( 0, 500, 1, this);
  setContrast->setValue( org_contrast );
  setContrast->setGeometry( QRect(120, 120, 80, 30) );
  setContrast->show();

  QLabel * contrastLabel = new QLabel( "Contrast (%)", this);
  contrastLabel->setGeometry( QRect(120, 90, 120, 30));
  contrastLabel->show();

  setLevel = new QSpinBox( 0, 255, 1, this);
  setLevel->setValue( org_level );
  setLevel->setGeometry( QRect(120, 180, 80, 30) );
  setLevel->show();

  QLabel * levelLabel = new QLabel( "Level", this);
  levelLabel->setGeometry( QRect(120, 150, 100, 30));
  levelLabel->show();

}

SetColorDialog::~SetColorDialog()
{
  // no need to delete child widgets, Qt does it all for us
}

int SetColorDialog::rgbColor()
{
  
  return ( (rBox->value()<<16) + (gBox->value()<<8) + (bBox->value()) );

}

bool SetColorDialog::gray()
{
  
  return ( setGray->isChecked() );

}

int SetColorDialog::contrast()
{
  
  return ( setContrast->value() );

}

int SetColorDialog::level()
{
  
  return ( setLevel->value() );

}
